Index: acct_mgr/templates/admin_accountsconfig.html
===================================================================
--- acct_mgr/templates/admin_accountsconfig.html	(revision 9431)
+++ acct_mgr/templates/admin_accountsconfig.html	(working copy)
@@ -7,9 +7,6 @@
       xmlns:i18n="http://genshi.edgewall.org/i18n"
       i18n:domain="acct_mgr">
   <xi:include href="admin.html" />
-  <?python
-    from acct_mgr.api import _
-  ?>
   <head>
     <title>Accounts: Configuration</title>
   </head>
@@ -69,7 +66,7 @@
       </fieldset>
 
       <div class="buttons">
-        <input type="submit" name="save" value="${_('Save')}" />
+        <input type="submit" name="save" value="${dgettext('acct_mgr', 'Save')}" />
       </div>
     </form>
   </body>
Index: acct_mgr/templates/admin_accountsnotification.html
===================================================================
--- acct_mgr/templates/admin_accountsnotification.html	(revision 9431)
+++ acct_mgr/templates/admin_accountsnotification.html	(working copy)
@@ -7,9 +7,6 @@
       xmlns:i18n="http://genshi.edgewall.org/i18n"
       i18n:domain="acct_mgr">
   <xi:include href="admin.html" />
-  <?python
-    from acct_mgr.api import _
-  ?>
   <head>
     <title>Accounts: Notification Configuration</title>
   </head>
@@ -43,7 +40,7 @@
                 name="notify_addresses">${ ' '.join(notify_addresses)}</textarea>
     </fieldset>
       <div class="buttons">
-        <input type="submit" name="save" value="${_('Save')}" />
+        <input type="submit" name="save" value="${dgettext('acct_mgr', 'Save')}" />
       </div>
     </form>
   </body>
Index: acct_mgr/templates/register.html
===================================================================
--- acct_mgr/templates/register.html	(revision 9431)
+++ acct_mgr/templates/register.html	(working copy)
@@ -53,7 +53,7 @@
               <input type="text" name="email" class="textwidget" size="20"  value="${acctmgr.email}"/>
             </label>
             <p>The email address is required for Trac to send you a
-              verification code.
+              verification token.
             </p>
             <p py:if="reset_password_enabled">Entering your email address will
               also enable you to reset your password if you ever forget it.
Index: acct_mgr/templates/reset_password.html
===================================================================
--- acct_mgr/templates/reset_password.html	(revision 9431)
+++ acct_mgr/templates/reset_password.html	(working copy)
@@ -26,13 +26,13 @@
       <py:choose>
       <div class="system-message" py:when="reset.logged_in">
         <h2>Already logged in</h2>
-        <p i18n:msg="href">You're already logged in.  If you need to change
+        <p i18n:msg="">You're already logged in. If you need to change
         your password please use the
         <a href="${href.prefs('account')}">Account Preferences</a> page.</p>
       </div>
 
-      <p py:when="reset.sent_to_email">A new password has been emailed to you at
-      ${reset.sent_to_email} .</p>
+      <p py:when="reset.sent_to_email" i18n:msg="email">A new password has been
+      emailed to you at ${reset.sent_to_email}.</p>
 
       <py:otherwise>
       <p>If you've forgot your password enter your username and
Index: acct_mgr/templates/admin_users.html
===================================================================
--- acct_mgr/templates/admin_users.html	(revision 9431)
+++ acct_mgr/templates/admin_users.html	(working copy)
@@ -7,9 +7,6 @@
       xmlns:i18n="http://genshi.edgewall.org/i18n"
       i18n:domain="acct_mgr">
   <xi:include href="admin.html" />
-  <?python
-    from acct_mgr.api import _
-  ?>
   <head>
     <title>Accounts</title>
   </head>
@@ -40,7 +37,7 @@
         </div>
         <p class="help">Add a new user account.</p>
         <div class="buttons">
-          <input type="submit" name="add" value="${_(' Add ')}" />
+          <input type="submit" name="add" value="${dgettext('acct_mgr', ' Add ')}" />
         </div>
       </fieldset>
     </form>
@@ -62,7 +59,7 @@
         </div>
         <p class="help">Change a user's password.</p>
         <div class="buttons">
-          <input type="submit" name="change" value="${_(' Change ')}" />
+          <input type="submit" name="change" value="${dgettext('acct_mgr', ' Change ')}" />
         </div>
       </fieldset>
     </form>
@@ -95,7 +92,7 @@
         </tbody>
       </table>
       <div class="buttons" py:if="delete_enabled">
-        <input type="submit" name="remove" value="${_('Remove selected accounts')}" />
+        <input type="submit" name="remove" value="${dgettext('acct_mgr', 'Remove selected accounts')}" />
       </div>
     </form>
     </py:choose>
Index: acct_mgr/web_ui.py
===================================================================
--- acct_mgr/web_ui.py	(revision 9431)
+++ acct_mgr/web_ui.py	(working copy)
@@ -647,11 +647,15 @@
                 req.authname, 
                 req.session['email_verification_token']
             )
+            # TRANSLATOR: An email has been sent to %(email)s with a token to
+            # %(link)s.
+            link = tag.a(_("verify your new email address"),
+                         href=req.href.verify_email())
             # TRANSLATOR: ... verify your new email address
             chrome.add_notice(req, Markup(tag.span(
-                _("An email has been sent to %(email)s with a token to ",
-                email=email), tag.a(_("verify your new email address"),
-                                    href=req.href.verify_email() ), ".")))
+                _("An email has been sent to %(email)s with a token to "
+                  "%(link)s.",
+                  email=email, link=link))))
         return template, data, content_type
 
     # IRequestHandler methods